---
title: WebGLRenderingContext.renderbufferStorage()
slug: Web/API/WebGLRenderingContext/renderbufferStorage
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.renderbufferStorage()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> creates and initializes a renderbuffer object's data store.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.renderbufferStorage(<var>target</var>, <var>internalFormat</var>, <var>width</var>, <var>height</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>target</dt>
 <dd>A {{domxref("Glenum")}} specifying the target renderbuffer object. Possible values:
 <ul>
  <li><code>gl.RENDERBUFFER</code>: Buffer data storage for single images in a renderable internal format.</li>
 </ul>
 </dd>
 <dt>internalFormat</dt>
 <dd>A {{domxref("Glenum")}} specifying the internal format of the renderbuffer. Possible values:
 <ul>
  <li><code>gl.RGBA4</code>: 4 red bits, 4 green bits, 4 blue bits 4 alpha bits.</li>
  <li><code>gl.RGB565</code>: 5 red bits, 6 green bits, 5 blue bits.</li>
  <li><code>gl.RGB5_A1</code>: 5 red bits, 5 green bits, 5 blue bits, 1 alpha bit.</li>
  <li><code>gl.DEPTH_COMPONENT16</code>: 16 depth bits.</li>
  <li><code>gl.STENCIL_INDEX8</code>: 8 stencil bits.</li>
  <li><code>gl.DEPTH_STENCIL</code></li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.R8</code></li>
    <li><code>gl.R8UI</code></li>
    <li><code>gl.R8I</code></li>
    <li><code>gl.R16UI</code></li>
    <li><code>gl.R16I</code></li>
    <li><code>gl.R32UI</code></li>
    <li><code>gl.R32I</code></li>
    <li><code>gl.RG8</code></li>
    <li><code>gl.RG8UI</code></li>
    <li><code>gl.RG8I</code></li>
    <li><code>gl.RG16UI</code></li>
    <li><code>gl.RG16I</code></li>
    <li><code>gl.RG32UI</code></li>
    <li><code>gl.RG32I</code></li>
    <li><code>gl.RGB8</code></li>
    <li><code>gl.RGBA8</code></li>
    <li><code>gl.SRGB8_ALPHA8</code> (also available as an extension for WebGL 1, see below)</li>
    <li><code>gl.RGB10_A2</code></li>
    <li><code>gl.RGBA8UI</code></li>
    <li><code>gl.RGBA8I</code></li>
    <li><code>gl.RGB10_A2UI</code></li>
    <li><code>gl.RGBA16UI</code></li>
    <li><code>gl.RGBA16I</code></li>
    <li><code>gl.RGBA32I</code></li>
    <li><code>gl.RGBA32UI</code></li>
    <li><code>gl.DEPTH_COMPONENT24</code></li>
    <li><code>gl.DEPTH_COMPONENT32F</code></li>
    <li><code>gl.DEPTH24_STENCIL8</code></li>
    <li><code>gl.DEPTH32F_STENCIL8</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("WEBGL_color_buffer_float")}} extension:
   <ul>
    <li><code>ext.RGBA32F_EXT</code>: RGBA 32-bit floating-point type.</li>
    <li><code>ext.RGB32F_EXT</code>: RGB 32-bit floating-point type.</li>
   </ul>
  </li>
  <li>When using the {{domxref("EXT_sRGB")}} extension:
   <ul>
    <li><code>ext.SRGB8_ALPHA8_EXT</code>: 8-bit sRGB and alpha.</li>
   </ul>
  </li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}} and the {{domxref("EXT_color_buffer_float")}} extension:
   <ul>
    <li><code>gl.R16F</code></li>
    <li><code>gl.RG16F</code></li>
    <li><code>gl.RGBA16F</code></li>
    <li><code>gl.R32F</code></li>
    <li><code>gl.RG32F</code></li>
    <li><code>gl.RGBA32F</code></li>
    <li><code>gl.R11F_G11F_B10F</code></li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt>width</dt>
 <dd>A {{domxref("GLsizei")}} specifying the width of the renderbuffer in pixels.</dd>
 <dt>height</dt>
 <dd>A {{domxref("GLsizei")}} specifying the height of the renderbuffer in pixels.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.renderbufferStorage(gl.RENDERBUFFER, gl.RGBA4, 256, 256);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.7", "renderbufferStorage")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glRenderbufferStorage.xml", "glRenderbufferStorage")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL ES 2 API.</td>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.5", "getRenderbufferParameter")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Updated definition for WebGL 2.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glRenderbufferStorage.xhtml", "glRenderbufferStorage")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 3 API.<br>
    Adds many new internal formats.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.renderbufferStorage")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.bindRenderbuffer()")}}</li>
 <li>{{domxref("WebGLRenderingContext.createRenderbuffer()")}}</li>
 <li>{{domxref("WebGLRenderingContext.deleteRenderbuffer()")}}</li>
 <li>{{domxref("WebGLRenderingContext.getRenderbufferParameter()")}}</li>
 <li>{{domxref("WEBGL_color_buffer_float")}}</li>
 <li>{{domxref("EXT_sRGB")}}</li>
 <li>{{domxref("EXT_color_buffer_float")}}</li>
 <li>{{domxref("EXT_texture_norm16")}}</li>
</ul>
